%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Gets consumption given gamma1, parameters, and lotteries
%
%
%C is a matrix C(i,s) is consumption on state s lottery i

function C = get_C(gamma1,param,L)

load_param;
C = zeros(2);

f = @(c,z,ind_gamma) ...
    ((c./x).^(-rho) .* (1+ ind_gamma) ./ x ) - ...
    delta .* (x + (1-delta).*(z - c)).^(-1);          % This is a formua for the FOC. It is positive near zero, and monotone decreasing.

for i=1:2
    if i==1
        Z = JA;
    else
        Z = JB;
    end;
    for j=1:length(JA)
        f2 = @(c) abs( f(c,Z(j),gamma1(i)) );
        mu = ((1+gamma1(i)))^(1/rho);             %This is a formula on the paper, for x+z below this threshold no self control is exerted and the consumer just consumes everything.
        if mu*x>=x+Z(j)
            C(i,j)=x+Z(j);
        else
            C(i,j) = fminbnd(f2,x,x+Z(j));              %I used this minimization because there were some robustness issues when using fzero.
        end;
    end
end;